Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 1821)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! icloud_scheme replaced by microphysics_*
 ! 
 ! Former revisions:
@@ -465,53 +465,51 @@
                        precipitation_rate(nysg:nyng,nxlg:nxrg) )
 
-             IF ( icloud_scheme == 0 )  THEN
-!
-!--             1D-arrays 
-                ALLOCATE ( nc_1d(nzb:nzt+1), pt_1d(nzb:nzt+1),                 &
-                           q_1d(nzb:nzt+1), qc_1d(nzb:nzt+1) ) 
-!
-!--             3D-cloud water content
+!
+!--          1D-arrays
+             ALLOCATE ( nc_1d(nzb:nzt+1), pt_1d(nzb:nzt+1),                 &
+                        q_1d(nzb:nzt+1), qc_1d(nzb:nzt+1) )
+!
+!--          3D-cloud water content
 #if defined( __nopointer )
-                ALLOCATE( qc(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             ALLOCATE( qc(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #else
-                ALLOCATE( qc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+             ALLOCATE( qc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #endif
-
-                IF ( precipitation )  THEN
-!
-!--                1D-arrays 
-                   ALLOCATE ( nr_1d(nzb:nzt+1), qr_1d(nzb:nzt+1) ) 
-
-!
-!--                2D-rain water content and rain drop concentration arrays
-                   ALLOCATE ( qrs(nysg:nyng,nxlg:nxrg),                        &
-                              qrsws(nysg:nyng,nxlg:nxrg),                      &
-                              qrswst(nysg:nyng,nxlg:nxrg),                     &
-                              nrs(nysg:nyng,nxlg:nxrg),                        &
-                              nrsws(nysg:nyng,nxlg:nxrg),                      &
-                              nrswst(nysg:nyng,nxlg:nxrg) )
-!
-!--                3D-rain water content, rain drop concentration arrays
+!
+!--          3d-precipitation rate
+             ALLOCATE( prr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+
+             IF ( microphysics_seifert )  THEN
+!
+!--             1D-arrays
+                ALLOCATE ( nr_1d(nzb:nzt+1), qr_1d(nzb:nzt+1) )
+
+!
+!--             2D-rain water content and rain drop concentration arrays
+                ALLOCATE ( qrs(nysg:nyng,nxlg:nxrg),                        &
+                           qrsws(nysg:nyng,nxlg:nxrg),                      &
+                           qrswst(nysg:nyng,nxlg:nxrg),                     &
+                           nrs(nysg:nyng,nxlg:nxrg),                        &
+                           nrsws(nysg:nyng,nxlg:nxrg),                      &
+                           nrswst(nysg:nyng,nxlg:nxrg) )
+!
+!--             3D-rain water content, rain drop concentration arrays
 #if defined( __nopointer )
-                   ALLOCATE( nr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                &
-                             nr_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
-                             qr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                &
-                             qr_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
-                             tnr_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),             &
-                             tqr_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ALLOCATE( nr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                &
+                          nr_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          qr(nzb:nzt+1,nysg:nyng,nxlg:nxrg),                &
+                          qr_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          tnr_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg),             &
+                          tqr_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #else
-                   ALLOCATE( nr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
-                             nr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
-                             nr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
-                             qr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
-                             qr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
-                             qr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+                ALLOCATE( nr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          nr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          nr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          qr_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          qr_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg),              &
+                          qr_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
 #endif
-!
-!--                3d-precipitation rate
-                   ALLOCATE( prr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                ENDIF
-
-             ENDIF
+             ENDIF
+
           ENDIF
 
@@ -658,10 +656,8 @@
           IF ( cloud_physics )  THEN
              ql => ql_1
-             IF ( icloud_scheme == 0 )  THEN
-                qc => qc_1
-                IF ( precipitation )  THEN
-                   qr => qr_1;  qr_p  => qr_2;  tqr_m  => qr_3
-                   nr => nr_1;  nr_p  => nr_2;  tnr_m  => nr_3
-                ENDIF
+             qc => qc_1
+             IF ( microphysics_seifert )  THEN
+                qr => qr_1;  qr_p  => qr_2;  tqr_m  => qr_3
+                nr => nr_1;  nr_p  => nr_2;  tnr_m  => nr_3
              ENDIF
           ENDIF
@@ -733,6 +729,5 @@
                 ENDDO
              ENDDO
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
-                  precipitation )  THEN
+             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
                 DO  i = nxlg, nxrg
                    DO  j = nysg, nyng
@@ -790,6 +785,5 @@
           IF ( humidity  .OR.  passive_scalar )  THEN
              qs = 0.0_wp
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
-                  precipitation )  THEN
+             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
                 qrs = 0.0_wp
                 nrs = 0.0_wp
@@ -880,17 +874,15 @@
                 ENDDO
              ENDDO
-             IF ( cloud_physics  .AND.  icloud_scheme == 0 )  THEN
+             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
 !
 !--             Initialze nc_1d with default value
                 nc_1d(:) = nc_const
 
-                IF ( precipitation )  THEN
-                   DO  i = nxlg, nxrg
-                      DO  j = nysg, nyng
-                         qr(:,j,i) = 0.0_wp
-                         nr(:,j,i) = 0.0_wp
-                      ENDDO
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      qr(:,j,i) = 0.0_wp
+                      nr(:,j,i) = 0.0_wp
                    ENDDO
-                ENDIF
+                ENDDO
 
              ENDIF
@@ -1078,6 +1070,5 @@
 !--       Determine the near-surface water flux
           IF ( humidity  .OR.  passive_scalar )  THEN
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
-                  precipitation )  THEN
+             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
                 qrsws = 0.0_wp
                 nrsws = 0.0_wp
@@ -1116,6 +1107,5 @@
              IF ( humidity  .OR.  passive_scalar )  THEN
                 qswst = 0.0_wp
-                IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.           &
-                     precipitation ) THEN
+                IF ( cloud_physics  .AND.  microphysics_seifert ) THEN
                    nrswst = 0.0_wp
                    qrswst = 0.0_wp
@@ -1157,6 +1147,5 @@
           IF ( humidity  .OR.  passive_scalar )  THEN
              IF (  .NOT.  constant_waterflux )  qsws   = 0.0_wp
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
-                  precipitation )  THEN
+             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
                 qrsws = 0.0_wp
                 nrsws = 0.0_wp
@@ -1200,7 +1189,9 @@
        IF ( cloud_physics )  THEN
           ql = 0.0_wp
-          IF ( precipitation )  precipitation_amount = 0.0_wp
-          IF ( icloud_scheme == 0 )  THEN
-             qc = 0.0_wp
+          qc = 0.0_wp
+
+          precipitation_amount = 0.0_wp
+
+          IF ( microphysics_seifert )  THEN
              nc_1d = nc_const
           ENDIF 
@@ -1240,10 +1231,9 @@
           tq_m = 0.0_wp
           q_p = q
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                 &
-               precipitation )  THEN
+          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
              tqr_m = 0.0_wp
-             qr_p = qr
+             qr_p  = qr
              tnr_m = 0.0_wp
-             nr_p = nr
+             nr_p  = nr
           ENDIF
        ENDIF
@@ -1426,6 +1416,5 @@
        IF ( humidity  .OR.  passive_scalar )  THEN
           q_p = q
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                 &
-               precipitation )  THEN
+          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
              qr_p = qr
              nr_p = nr
@@ -1441,6 +1430,5 @@
        IF ( humidity  .OR.  passive_scalar )  THEN
           tq_m = 0.0_wp
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                 &
-               precipitation )  THEN
+          IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
              tqr_m = 0.0_wp
              tnr_m = 0.0_wp
Index: palm/trunk/SOURCE/init_cloud_physics.f90
===================================================================
--- palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1821)
+++ palm/trunk/SOURCE/init_cloud_physics.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! icloud_scheme replaced by microphysics_*
 ! 
 ! Former revisions:
@@ -92,5 +92,5 @@
         
     USE control_parameters,                                                    &
-        ONLY:  g, icloud_scheme, message_string, precipitation, pt_surface,    &
+        ONLY:  g, message_string, microphysics_seifert, pt_surface,            &
                rho_surface, surface_pressure
     
@@ -126,5 +126,5 @@
 !
 !-- Calculate timestep according to precipitation
-    IF ( icloud_scheme == 0  .AND.  precipitation )  THEN
+    IF ( microphysics_seifert )  THEN
        dt_precipitation = c_sedimentation * MINVAL( dzu(nzb+2:nzt) ) /         &
                           w_precipitation
Index: palm/trunk/SOURCE/init_masks.f90
===================================================================
--- palm/trunk/SOURCE/init_masks.f90	(revision 1821)
+++ palm/trunk/SOURCE/init_masks.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! icloud_scheme replaced by microphysics_*
 ! 
 ! Former revisions:
@@ -97,10 +97,10 @@
                data_output_masks, data_output_masks_user,                      &
                doav, doav_n, domask, domask_no, dz, dz_stretch_level, humidity,&
-               icloud_scheme, mask, masks, mask_scale, mask_i,                 &
+               mask, masks, mask_scale, mask_i,                                &
                mask_i_global, mask_j, mask_j_global, mask_k, mask_k_global,    &
                mask_loop, mask_size, mask_size_l, mask_start_l, mask_x,        &
                mask_x_loop, mask_xyz_dimension, mask_y, mask_y_loop, mask_z,   &
                mask_z_loop, max_masks,  message_string, mid,                   &
-               passive_scalar, precipitation, ocean
+               microphysics_seifert, passive_scalar, ocean
 
     USE grid_variables,                                                        &
@@ -270,12 +270,8 @@
                         '" requires cloud_physics = .TRUE.'
                    CALL message( 'init_masks', 'PA0108', 1, 2, 0, 6, 0 )
-                 ELSEIF ( icloud_scheme /= 0 ) THEN
+                 ELSEIF ( .NOT. microphysics_seifert ) THEN
                    message_string = 'output of "' // TRIM( var ) // '" requi' //  &
                          'res cloud_scheme = seifert_beheng'
                    CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
-                 ELSEIF ( .NOT. precipitation )  THEN
-                   message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                 'res precipitation = .TRUE.'
-                   CALL message( 'check_parameters', 'PA0112', 1, 2, 0, 6, 0 )
                 ENDIF
                 unit = '1/m3'
@@ -305,8 +301,4 @@
                             'res cloud_physics = .TRUE.'
                    CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
-                ELSEIF ( icloud_scheme /= 0 ) THEN
-                   message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                            'res cloud_scheme = seifert_beheng'
-                   CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
                 ENDIF
                 unit = 'kg/kg'
@@ -344,12 +336,8 @@
                             'res cloud_physics = .TRUE.'
                    CALL message( 'check_parameters', 'PA0108', 1, 2, 0, 6, 0 )
-                ELSEIF ( icloud_scheme /= 0 ) THEN
+                ELSEIF ( .NOT. microphysics_seifert ) THEN
                    message_string = 'output of "' // TRIM( var ) // '" requi' //  &
                             'res cloud_scheme = seifert_beheng'
                    CALL message( 'check_parameters', 'PA0359', 1, 2, 0, 6, 0 )
-                ELSEIF ( .NOT. precipitation )  THEN
-                   message_string = 'output of "' // TRIM( var ) // '" requi' //  &
-                                    'res precipitation = .TRUE.'
-                   CALL message( 'check_parameters', 'PA0112', 1, 2, 0, 6, 0 )
                 ENDIF
                 unit = 'kg/kg'
Index: palm/trunk/SOURCE/interaction_droplets_ptq.f90
===================================================================
--- palm/trunk/SOURCE/interaction_droplets_ptq.f90	(revision 1821)
+++ palm/trunk/SOURCE/interaction_droplets_ptq.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Unused variables removed.
 !
 ! Former revisions:
@@ -127,5 +127,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nzb_2d, nzt
+           ONLY:  nzb_2d, nzt
 
        USE kinds,                                                              &
Index: palm/trunk/SOURCE/lpm.f90
===================================================================
--- palm/trunk/SOURCE/lpm.f90	(revision 1821)
+++ palm/trunk/SOURCE/lpm.f90	(revision 1822)
@@ -19,5 +19,12 @@
 ! Current revisions:
 ! ------------------
-! 
+! Tails removed.
+!
+! Initialization of sgs model not necessary for the use of cloud_droplets and
+! use_sgs_for_particles.
+!
+! lpm_release_set integrated.
+!
+! Unused variabled removed.
 ! 
 ! Former revisions:
@@ -108,16 +115,19 @@
         ONLY:  lpm_exchange_horiz, lpm_move_particle
 
+    USE lpm_init_mod,                                                          &
+        ONLY: lpm_create_particle, PHASE_RELEASE
+
     USE lpm_pack_arrays_mod,                                                   &
         ONLY:  lpm_pack_all_arrays
 
     USE particle_attributes,                                                   &
-        ONLY:  collision_kernel, deleted_particles, deleted_tails,             &
+        ONLY:  collision_kernel, deleted_particles,                            &
                dt_write_particle_data, dt_prel, end_time_prel,                 &
                grid_particles, number_of_particles, number_of_particle_groups, &
                particles, particle_groups, prt_count, trlp_count_sum,          &
-               tail_mask, time_prel, time_sort_particles,                      &
+               time_prel,                                                      &
                time_write_particle_data, trlp_count_recv_sum, trnp_count_sum,  &
                trnp_count_recv_sum, trrp_count_sum, trrp_count_recv_sum,       &
-               trsp_count_sum, trsp_count_recv_sum, use_particle_tails,        &
+               trsp_count_sum, trsp_count_recv_sum,                            &
                use_sgs_for_particles, write_particle_statistics
 
@@ -159,13 +169,7 @@
 
 !
-!-- Initialize arrays for marking those particles/tails to be deleted after the
+!-- Initialize arrays for marking those particles to be deleted after the
 !-- (sub-) timestep
     deleted_particles = 0
-
-    IF ( use_particle_tails )  THEN
-       tail_mask = .TRUE.
-    ENDIF
-    deleted_tails = 0
-
 
 !
@@ -202,5 +206,5 @@
     IF ( time_prel >= dt_prel  .AND.  end_time_prel > simulated_time )  THEN
 
-       CALL lpm_release_set
+       CALL lpm_create_particle(PHASE_RELEASE)
 !
 !--    The MOD function allows for changes in the output interval with
@@ -240,5 +244,7 @@
 !--    velocity variances)
 
-       IF ( use_sgs_for_particles )  CALL lpm_init_sgs_tke
+       IF ( use_sgs_for_particles  .AND.  .NOT. cloud_droplets )  THEN
+          CALL lpm_init_sgs_tke
+       ENDIF
 
        DO  i = nxl, nxr
@@ -361,10 +367,4 @@
        deleted_particles = 0
 
-       IF ( use_particle_tails )  THEN
-          tail_mask     = .TRUE.
-       ENDIF
-       deleted_tails = 0
-
-
        IF ( dt_3d_reached )  EXIT
 
@@ -387,16 +387,7 @@
     IF ( collision_kernel == 'none' )  CALL lpm_set_attributes
 
-
 !
 !-- Set particle attributes defined by the user
     CALL user_lpm_set_attributes
-
-
-!
-!-- particle tails currently not available
-!
-!-- If required, add the current particle positions to the particle tails
-!   IF ( use_particle_tails )  CALL lpm_extend_tails
-
 
 !
Index: palm/trunk/SOURCE/lpm_advec.f90
===================================================================
--- palm/trunk/SOURCE/lpm_advec.f90	(revision 1821)
+++ palm/trunk/SOURCE/lpm_advec.f90	(revision 1822)
@@ -19,5 +19,10 @@
 ! Current revisions:
 ! ------------------
-! 
+! Random velocity fluctuations for particles added. Terminal fall velocity
+! for droplets is calculated from a parameterization (which is better than
+! the previous, physically correct calculation, which demands a very short
+! time step that is not used in the model).
+!
+! Unused variables deleted.
 ! 
 ! Former revisions:
@@ -78,6 +83,5 @@
 
     USE arrays_3d,                                                             &
-        ONLY:  de_dx, de_dy, de_dz, diss, e, u, us, usws, v, vsws, w, z0, zu,  &
-               zw
+        ONLY:  de_dx, de_dy, de_dz, diss, e, km, u, us, usws, v, vsws, w, zu, zw
 
     USE cpulog
@@ -87,6 +91,5 @@
     USE control_parameters,                                                    &
         ONLY:  atmos_ocean_sign, cloud_droplets, constant_flux_layer, dt_3d,   &
-               dt_3d_reached_l, dz, g, kappa, molecular_viscosity, topography, &
-               u_gtrans, v_gtrans, simulated_time
+               dt_3d_reached_l, dz, g, kappa, topography, u_gtrans, v_gtrans
 
     USE grid_variables,                                                        &
@@ -99,5 +102,5 @@
     
     USE particle_attributes,                                                   &
-        ONLY:  block_offset, c_0, density_ratio, dt_min_part, grid_particles,  &
+        ONLY:  block_offset, c_0, dt_min_part, grid_particles,                 &
                iran_part, log_z_z0, number_of_particles, number_of_sublayers,  &
                particles, particle_groups, offset_ocean_nzt, sgs_wfu_part,     &
@@ -140,4 +143,5 @@
     REAL(wp) ::  de_dz_int_l        !<
     REAL(wp) ::  de_dz_int_u        !<
+    REAL(wp) ::  diameter           !< diamter of droplet
     REAL(wp) ::  diss_int_l         !<
     REAL(wp) ::  diss_int_u         !<
@@ -150,9 +154,13 @@
     REAL(wp) ::  exp_term           !<
     REAL(wp) ::  gg                 !<
-    REAL(wp) ::  height_int         !<
     REAL(wp) ::  height_p           !<
-    REAL(wp) ::  lagr_timescale     !<
+    REAL(wp) ::  lagr_timescale     !< Lagrangian timescale
     REAL(wp) ::  location(1:30,1:3) !<
     REAL(wp) ::  random_gauss       !<
+    REAL(wp) ::  RL                 !< Lagrangian autocorrelation coefficient
+    REAL(wp) ::  rg1                !< Gaussian distributed random number
+    REAL(wp) ::  rg2                !< Gaussian distributed random number
+    REAL(wp) ::  rg3                !< Gaussian distributed random number
+    REAL(wp) ::  sigma              !< velocity standard deviation
     REAL(wp) ::  u_int_l            !<
     REAL(wp) ::  u_int_u            !<
@@ -163,7 +171,15 @@
     REAL(wp) ::  w_int_l            !<
     REAL(wp) ::  w_int_u            !<
+    REAL(wp) ::  w_s                !< terminal velocity of droplets
     REAL(wp) ::  x                  !<
     REAL(wp) ::  y                  !<
-    REAL(wp) ::  z_p                !<    
+    REAL(wp) ::  z_p                !<
+
+    REAL(wp), PARAMETER ::  a_rog = 9.65_wp      !< parameter for fall velocity
+    REAL(wp), PARAMETER ::  b_rog = 10.43_wp     !< parameter for fall velocity
+    REAL(wp), PARAMETER ::  c_rog = 0.6_wp       !< parameter for fall velocity
+    REAL(wp), PARAMETER ::  k_cap_rog = 4.0_wp   !< parameter for fall velocity
+    REAL(wp), PARAMETER ::  k_low_rog = 12.0_wp  !< parameter for fall velocity
+    REAL(wp), PARAMETER ::  d0_rog = 0.745_wp    !< separation diameter
 
     REAL(wp), DIMENSION(1:30) ::  d_gp_pl !<
@@ -388,5 +404,5 @@
 !-- Interpolate and calculate quantities needed for calculating the SGS
 !-- velocities
-    IF ( use_sgs_for_particles )  THEN
+    IF ( use_sgs_for_particles  .AND.  .NOT. cloud_droplets )  THEN
 
        IF ( topography == 'flat' )  THEN
@@ -1336,15 +1352,116 @@
 !--          Update of the particle velocity
              IF ( cloud_droplets )  THEN
-                exp_arg  = 4.5_wp * dens_ratio(n) * molecular_viscosity /      &
-                           ( particles(n)%radius )**2 *                        &
-                           ( 1.0_wp + 0.15_wp * ( 2.0_wp * particles(n)%radius &
-                             * SQRT( ( u_int(n) - particles(n)%speed_x )**2 +  &
-                                     ( v_int(n) - particles(n)%speed_y )**2 +  &
-                                     ( w_int(n) - particles(n)%speed_z )**2 )  &
-                                          / molecular_viscosity )**0.687_wp    &
-                           )
-
-                exp_term = EXP( -exp_arg * dt_particle(n) )
-             ELSEIF ( use_sgs_for_particles )  THEN
+!
+!--             Terminal velocity is computed for vertical direction (Rogers et 
+!--             al., 1993, J. Appl. Meteorol.)
+                diameter = particles(n)%radius * 2000.0_wp !diameter in mm
+                IF ( diameter <= d0_rog )  THEN
+                   w_s = k_cap_rog * diameter * ( 1.0_wp - EXP( -k_low_rog * diameter ) )
+                ELSE
+                   w_s = a_rog - b_rog * EXP( -c_rog * diameter )
+                ENDIF
+
+!
+!--             If selected, add random velocities following Soelch and Kaercher
+!--             (2010, Q. J. R. Meteorol. Soc.)
+                IF ( use_sgs_for_particles )  THEN
+                   lagr_timescale = km(kp,jp,ip) / MAX( e(kp,jp,ip), 1.0E-20_wp )
+                   RL             = EXP( -1.0_wp * dt_3d / lagr_timescale )
+                   sigma          = SQRT( e(kp,jp,ip) )
+
+                   rg1 = random_gauss( iran_part, 5.0_wp ) - 1.0_wp
+                   rg2 = random_gauss( iran_part, 5.0_wp ) - 1.0_wp
+                   rg3 = random_gauss( iran_part, 5.0_wp ) - 1.0_wp
+
+                   particles(n)%rvar1 = RL * particles(n)%rvar1 +              &
+                                        SQRT( 1.0_wp - RL**2 ) * sigma * rg1
+                   particles(n)%rvar2 = RL * particles(n)%rvar2 +              &
+                                        SQRT( 1.0_wp - RL**2 ) * sigma * rg2
+                   particles(n)%rvar3 = RL * particles(n)%rvar3 +              &
+                                        SQRT( 1.0_wp - RL**2 ) * sigma * rg3
+
+                   particles(n)%speed_x = u_int(n) + particles(n)%rvar1
+                   particles(n)%speed_y = v_int(n) + particles(n)%rvar2
+                   particles(n)%speed_z = w_int(n) + particles(n)%rvar3 - w_s
+                ELSE
+                   particles(n)%speed_x = u_int(n)
+                   particles(n)%speed_y = v_int(n)
+                   particles(n)%speed_z = w_int(n) - w_s
+                ENDIF
+
+             ELSE
+
+                IF ( use_sgs_for_particles )  THEN
+                   exp_arg  = particle_groups(particles(n)%group)%exp_arg
+                   exp_term = EXP( -exp_arg * dt_particle(n) )
+                ELSE
+                   exp_arg  = particle_groups(particles(n)%group)%exp_arg
+                   exp_term = particle_groups(particles(n)%group)%exp_term
+                ENDIF
+                particles(n)%speed_x = particles(n)%speed_x * exp_term +         &
+                                       u_int(n) * ( 1.0_wp - exp_term )
+                particles(n)%speed_y = particles(n)%speed_y * exp_term +         &
+                                       v_int(n) * ( 1.0_wp - exp_term )
+                particles(n)%speed_z = particles(n)%speed_z * exp_term +         &
+                                       ( w_int(n) - ( 1.0_wp - dens_ratio(n) ) * &
+                                       g / exp_arg ) * ( 1.0_wp - exp_term )
+             ENDIF
+
+          ENDIF
+
+       ENDDO
+    
+    ELSE
+
+       DO  n = 1, number_of_particles
+
+!--       Transport of particles with inertia
+          particles(n)%x = xv(n) + particles(n)%speed_x * dt_particle(n)
+          particles(n)%y = yv(n) + particles(n)%speed_y * dt_particle(n)
+          particles(n)%z = zv(n) + particles(n)%speed_z * dt_particle(n)
+!
+!--       Update of the particle velocity
+          IF ( cloud_droplets )  THEN
+!
+!--          Terminal velocity is computed for vertical direction (Rogers et al., 
+!--          1993, J. Appl. Meteorol.)
+             diameter = particles(n)%radius * 2000.0_wp !diameter in mm
+             IF ( diameter <= d0_rog )  THEN
+                w_s = k_cap_rog * diameter * ( 1.0_wp - EXP( -k_low_rog * diameter ) )
+             ELSE
+                w_s = a_rog - b_rog * EXP( -c_rog * diameter )
+             ENDIF
+
+!
+!--          If selected, add random velocities following Soelch and Kaercher
+!--          (2010, Q. J. R. Meteorol. Soc.)
+             IF ( use_sgs_for_particles )  THEN
+                 lagr_timescale = km(kp,jp,ip) / MAX( e(kp,jp,ip), 1.0E-20_wp )
+                 RL             = EXP( -1.0_wp * dt_3d / lagr_timescale )
+                 sigma          = SQRT( e(kp,jp,ip) )
+
+                 rg1 = random_gauss( iran_part, 5.0_wp ) - 1.0_wp
+                 rg2 = random_gauss( iran_part, 5.0_wp ) - 1.0_wp
+                 rg3 = random_gauss( iran_part, 5.0_wp ) - 1.0_wp
+
+                 particles(n)%rvar1 = RL * particles(n)%rvar1 +                &
+                                      SQRT( 1.0_wp - RL**2 ) * sigma * rg1
+                 particles(n)%rvar2 = RL * particles(n)%rvar2 +                &
+                                      SQRT( 1.0_wp - RL**2 ) * sigma * rg2
+                 particles(n)%rvar3 = RL * particles(n)%rvar3 +                &
+                                      SQRT( 1.0_wp - RL**2 ) * sigma * rg3
+
+                 particles(n)%speed_x = u_int(n) + particles(n)%rvar1
+                 particles(n)%speed_y = v_int(n) + particles(n)%rvar2
+                 particles(n)%speed_z = w_int(n) + particles(n)%rvar3 - w_s
+             ELSE
+                 particles(n)%speed_x = u_int(n)
+                 particles(n)%speed_y = v_int(n)
+                 particles(n)%speed_z = w_int(n) - w_s
+             ENDIF
+
+          ELSE
+
+             IF ( use_sgs_for_particles )  THEN
                 exp_arg  = particle_groups(particles(n)%group)%exp_arg
                 exp_term = EXP( -exp_arg * dt_particle(n) )
@@ -1353,51 +1470,13 @@
                 exp_term = particle_groups(particles(n)%group)%exp_term
              ENDIF
-             particles(n)%speed_x = particles(n)%speed_x * exp_term +          &
+             particles(n)%speed_x = particles(n)%speed_x * exp_term +             &
                                     u_int(n) * ( 1.0_wp - exp_term )
-             particles(n)%speed_y = particles(n)%speed_y * exp_term +          &
+             particles(n)%speed_y = particles(n)%speed_y * exp_term +             &
                                     v_int(n) * ( 1.0_wp - exp_term )
-             particles(n)%speed_z = particles(n)%speed_z * exp_term +          &
-                                    ( w_int(n) - ( 1.0_wp - dens_ratio(n) ) *  &
-                                    g / exp_arg ) * ( 1.0_wp - exp_term )
+             particles(n)%speed_z = particles(n)%speed_z * exp_term +             &
+                                    ( w_int(n) - ( 1.0_wp - dens_ratio(n) ) * g / &
+                                    exp_arg ) * ( 1.0_wp - exp_term )
           ENDIF
 
-       ENDDO
-    
-    ELSE
-
-       DO  n = 1, number_of_particles
-
-!--       Transport of particles with inertia
-          particles(n)%x = xv(n) + particles(n)%speed_x * dt_particle(n)
-          particles(n)%y = yv(n) + particles(n)%speed_y * dt_particle(n)
-          particles(n)%z = zv(n) + particles(n)%speed_z * dt_particle(n)
-!
-!--       Update of the particle velocity
-          IF ( cloud_droplets )  THEN
-
-             exp_arg  = 4.5_wp * dens_ratio(n) * molecular_viscosity /         &
-                        ( particles(n)%radius )**2 *                           &
-                        ( 1.0_wp + 0.15_wp * ( 2.0_wp * particles(n)%radius *  &
-                          SQRT( ( u_int(n) - particles(n)%speed_x )**2 +       &
-                                ( v_int(n) - particles(n)%speed_y )**2 +       &
-                                ( w_int(n) - particles(n)%speed_z )**2 ) /     &
-                                         molecular_viscosity )**0.687_wp       &
-                        )
-
-             exp_term = EXP( -exp_arg * dt_particle(n) )
-          ELSEIF ( use_sgs_for_particles )  THEN
-             exp_arg  = particle_groups(particles(n)%group)%exp_arg
-             exp_term = EXP( -exp_arg * dt_particle(n) )
-          ELSE
-             exp_arg  = particle_groups(particles(n)%group)%exp_arg
-             exp_term = particle_groups(particles(n)%group)%exp_term
-          ENDIF
-          particles(n)%speed_x = particles(n)%speed_x * exp_term +             &
-                                 u_int(n) * ( 1.0_wp - exp_term )
-          particles(n)%speed_y = particles(n)%speed_y * exp_term +             &
-                                 v_int(n) * ( 1.0_wp - exp_term )
-          particles(n)%speed_z = particles(n)%speed_z * exp_term +             &
-                                 ( w_int(n) - ( 1.0_wp - dens_ratio(n) ) * g / &
-                                 exp_arg ) * ( 1.0_wp - exp_term )
        ENDDO
 
